package com.yanzhu.manage.controller;

import com.alibaba.fastjson2.JSONObject;
import com.yanzhu.common.core.utils.DateUtils;
import com.yanzhu.common.core.web.domain.AjaxResult;
import com.yanzhu.manage.domain.AttendanceUbiData;
import com.yanzhu.manage.domain.ProProjectInfoSubdeptsUsers;
import com.yanzhu.manage.service.IAttendanceUbiDataService;
import com.yanzhu.manage.service.IProProjectInfoSubdeptsUsersService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/uni/callback")
public class UniCallBackController {

    @Autowired
    private IAttendanceUbiDataService attendanceUbiDataService;

    @Autowired
    private IProProjectInfoSubdeptsUsersService proProjectInfoSubdeptsUsersService;
    /**
     * 识别回调
     * @param jo
     * @return
     */
    @PostMapping("/recognize")
    public AjaxResult recognize(HttpServletRequest request){
        String data=request.getParameter("eventMsg");
        JSONObject json=JSONObject.parseObject(data);
        int type=json.getInteger("type");
        if(type==1){// 人员比对结果,1:比对成功 2:比对失败
            String eventGuid=request.getParameter("eventGuid");
            String admitGuid=json.getString("admitGuid");
            long projectId=Long.parseLong(json.getString("cardNo"));
            String deviceNo=json.getString("deviceNo");
            String filePath=json.getString("filePath");
            Date showTime=new Date(json.getLong("showTime"));
            AttendanceUbiData where=new AttendanceUbiData();
            where.setAdmitGuid(admitGuid);
            where.setInTime(showTime);
            List<AttendanceUbiData> list= attendanceUbiDataService.queryAttendaceInfo(where);
            if(list.size()==0){
                //增加操作
                ProProjectInfoSubdeptsUsers userWhere=new ProProjectInfoSubdeptsUsers();
                userWhere.setProjectId(projectId);
                userWhere.setAdmitGuid(admitGuid);
                List<ProProjectInfoSubdeptsUsers> userList=proProjectInfoSubdeptsUsersService.selectProProjectInfoSubdeptsUsersList(userWhere);
                if(userList.size()>0){
                    ProProjectInfoSubdeptsUsers proUser=userList.get(0);
                    if(proUser!=null && proUser.getUser()!=null){
                        AttendanceUbiData addData=new AttendanceUbiData();
                        addData.setAdmitGuid(admitGuid);
                        addData.setComName(proUser.getActiveComName());
                        addData.setProjectName(proUser.getProjectName());
                        addData.setComId(proUser.getComId());
                        addData.setUserId(proUser.getUserId());
                        addData.setProjectId(projectId);
                        addData.setEventGuid(eventGuid);
                        addData.setUserName(proUser.getUser().getUserName());
                        addData.setSubDeptGroup(proUser.getSubDeptGroup());
                        addData.setSubDeptGroupName(proUser.getSubDeptGroupName());
                        addData.setCraftPost(proUser.getCraftPost());
                        addData.setCraftType(proUser.getCraftType());
                        addData.setInTime(showTime);
                        addData.setInData(data);
                        addData.setInPhoto(filePath);
                        addData.setDeviceNo(deviceNo);
                        attendanceUbiDataService.insertAttendanceUbiData(addData);
                        return AjaxResult.success("增加成功");
                    }
                }
            }else{
                //修改操作
                AttendanceUbiData upData= list.get(0);
                if(upData.getEventGuid().equals(eventGuid)){
                    return  AjaxResult.error("此记录已入库!");
                }
                Date dt1=upData.getInTime();
                Date dt2=upData.getOutTime();
                if(dt1!=null && dt2!=null){
                    if(showTime.getTime()<dt1.getTime()){
                        upData.setInPhoto(filePath);
                        upData.setInData(data);
                        upData.setInTime(showTime);
                    }
                    if(showTime.getTime()>dt2.getTime()){
                        upData.setOutData(data);
                        upData.setOutPhoto(filePath);
                        upData.setOutTime(showTime);
                    }
                }else{
                    if(showTime.getTime()<dt1.getTime()){
                        upData.setOutTime(upData.getInTime());
                        upData.setOutData(upData.getInData());
                        upData.setOutPhoto(upData.getInPhoto());
                        upData.setInPhoto(filePath);
                        upData.setInData(data);
                        upData.setInTime(showTime);
                    }
                    if(showTime.getTime()>dt1.getTime()){
                        upData.setOutData(data);
                        upData.setOutPhoto(filePath);
                        upData.setOutTime(showTime);
                    }
                }
                attendanceUbiDataService.updateAttendanceUbiData(upData);
                return AjaxResult.success("更新成功");
            }

        }
        return AjaxResult.error("同步失败");
    }

    /**
     * 授权回调
     * @param jo
     * @return
     */
    @PostMapping("/auth")
    public AjaxResult auth(@RequestBody JSONObject jo){
        return AjaxResult.success("--ok--");
    }

    /**
     * 销权回调
     * @param jo
     * @return
     */
    @PostMapping("/unauth")
    public AjaxResult unauth(@RequestBody JSONObject jo){
        return AjaxResult.success("--ok--");
    }

    /**
     * 警报回调
     * @param jo
     * @return
     */
    @PostMapping("/alarm")
    public AjaxResult alarm(@RequestBody JSONObject jo){
        return AjaxResult.success("--ok--");
    }

    /**
     * 设备删除回调
     * @param jo
     * @return
     */
    @PostMapping("/deviceDelete")
    public AjaxResult deviceDelete(@RequestBody JSONObject jo){
        return AjaxResult.success("--ok--");
    }
}
